<%@ page contentType="text/html; charset=utf-8" %>
<%@ page language="java" %>
<%@ page errorPage="/errorPage.jsp" %>
<% try { // START: DEBUG %>
<%@ taglib uri="/WEB-INF/citation.tld" prefix="citation" %>
<%@ taglib uri="/WEB-INF/struts-tiles.tld" prefix="tiles" %>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ page import="com.sas.apps.citation.model.user.SessionScopeManager
        ,com.sas.apps.citation.view.beans.PagePropertyBean
        ,com.sas.apps.citation.view.beans.SectionPaneFormBean
        ,com.sas.apps.citation.view.beans.reportmanagement.OpenReport
        ,com.sas.apps.citation.view.beans.reportmanagement.OpenReportManager
        ,com.sas.apps.citation.view.contentgeneration.TaskPaneContentGenerator
        ,com.sas.apps.citation.view.contentgeneration.report.PageContentsInterface
        ,com.sas.apps.citation.controller.action.report.ReportControllerAction
        ,com.sas.apps.citation.view.util.ThemeUtils
        ,com.sas.apps.citation.view.beans.CommonLayoutSessionBean
        ,com.sas.apps.citation.util.CitationException
        ,com.sas.apps.citation.view.util.PageErrorProcessor" 
        %>
<html:xhtml />

<%
    SessionScopeManager smgr    = SessionScopeManager.getSessionScopeManager(request);
    OpenReport openReport       = OpenReportManager.getCurrentOpenReport(smgr);
  
    //no need to pollute session with objects only necessary for an isolated request
    SectionPaneFormBean sectionPaneForm = new SectionPaneFormBean();
    sectionPaneForm.initialize(smgr, openReport);

    boolean isViewMode = false;
    int sectionCount = 0;
    boolean sectionPaneOpen = true;
    String sectionPaneStyle = null;
    CommonLayoutSessionBean commonLayout = null;


    if (openReport != null)
    {
      isViewMode = (OpenReportManager.REPORT_SESSION_MODE_VIEWER == OpenReportManager.getReportSessionMode(smgr));
      sectionCount = openReport.getSectionCount();
    } 
    int groupBreakCount = sectionPaneForm.getGroupBreakCount();
    
    int currentSectionIndex = sectionPaneForm.getCurrentSectionIndex();

    PageContentsInterface reportPageContents  = null;
    boolean isTocAvailable = false;
    
    if (isViewMode)
    {
       reportPageContents = openReport.getPageContents();
       isTocAvailable = reportPageContents != null && reportPageContents.hasTableOfContents();
    }   
    
    try {
       commonLayout = CommonLayoutSessionBean.getCommonLayoutSessionBean(request);
       sectionPaneOpen = commonLayout.isSectionPaneOpen();
    } catch (CitationException e) {
    } finally {
       if (!sectionPaneOpen) {
          sectionPaneStyle = "visibility:hidden; display:none;";
       } else {
          sectionPaneStyle = "visibility:visible; display:block;";
       }
    }


%>         
<script type="text/javascript" src="scripts/citation_treeutils.js"></script>
<table class="taskPaneCollapseAreaWithBorderInside" summary="">
  <tr>
    <td>
       <table cellpadding="0" cellspacing="0" class="taskPaneCollapseHeaderAreaCellNoBorder" style="text-align:left; width:100%;" summary="">
          <tr>
            <td class="taskPaneCollapseHeaderAreaCell">
                  <input type="image"
                  id="taskPaneSectionsExpandCollapseButton"
                  alt=""
                  src="<%=ThemeUtils.getImageSourceURL(request, "wrs_Foldup_Taskpane")%>"
<%                if (isViewMode)
                  {                  
%>         
                     onclick="g_sectionsButtonToggle.toggle(event, this, 'toggleSectionPaneOpen.do'); wrsReportContentAreaAdjust(event); return false;"/>
<%                }
                  else
                  {
%>         
                     onclick="g_sectionsButtonToggle.toggle(event, this, 'toggleSectionPaneOpen.do'); return false;"/>
<%                }
%>         
           </td>
           <td class="taskPaneCollapseHeaderAreaCell"><%=PagePropertyBean.getLabel(pageContext, "taskPane.groupBreaks.tableOfContents.header.txt")%></td>
           <td class="dialogSpacer taskPaneCollapseHeaderAreaCell">&nbsp;</td>
           <td class="taskPaneCollapseHeaderAreaCell" style="text-align:right; width:100%;">
<% 
              sectionPaneForm.writeSectionOptionsMenu(pageContext, out);
%>
           </td> 
          </tr>  
       </table>  
    </td>
    
  </tr>
  <tr>
    <td>
    
      <div id="taskPaneTableOfContents" style="<%=sectionPaneStyle%>">
        <table cellpadding="0" cellspacing="0" style="width:100%;" summary="">
          <tr>
            <td id="taskPaneSectionSelector">  
<% 
              TaskPaneContentGenerator.writeSectionSelector(request, out);
%>
            </td>
          </tr>
          <tr>
             <td>
        <%  if (openReport != null) { 
                    if (isTocAvailable || groupBreakCount > 0) { // S0626544 - only show pane if there are contents - jlw
                        %>
                        <div id="taskPaneGroupBreaks">
                        <% 
                        if (isTocAvailable) {
                            out.write(reportPageContents.getTableOfContents());
                        } else if (groupBreakCount > 0) {   
                            TaskPaneContentGenerator.writeGroupBreaksList(openReport, request, out);
                        }
                        %>
                       </div>
                        <%
                    } 
                }
        %>
            </td>
             </tr>
        </table>  
      </div>
    </td>
  </tr>  
</table>
<script type="text/javascript"> /*<![CDATA[*/
function scrollSelectedGroupBreakIntoView() {
    var groupBreakTreeObj = sas_getJavaScriptObject("wrs_tableOfContentsTree");
    if(groupBreakTreeObj != null)
    {
        WRSTreeUtil.focusAndScrollToSelection(groupBreakTreeObj);
    }
}

dojo.addOnLoad(scrollSelectedGroupBreakIntoView);

/*]]>*/ </script>





<%
   if (isViewMode) {
%>    
    <script type="text/javascript"> /*<![CDATA[*/
    var g_viewModeSectionSwitchLinks = new Array(<%=sectionCount%>);
    <% for (int iSec = 0; iSec < sectionCount; iSec++) { %>
         g_viewModeSectionSwitchLinks[<%=iSec%>] = '<%=ReportControllerAction.createGotoViewerSectionLink(iSec)%>';
<% }  %>  
   function taskPaneSectionSwitch(event, selector)
   {
      showDebugMsgs("section Switch to", selector.selectedIndex);
      
      if(gotoReportSection) // S0915162
      {
         gotoReportSection(""+selector.selectedIndex);
      }
      else
      {
         window.location =  g_viewModeSectionSwitchLinks[selector.selectedIndex];   
      }
   }
   function taskPaneNextSectionSwitch(event, sectionIndex)
   {
      showDebugMsgs("section Switch to", sectionIndex);
      window.location =  g_viewModeSectionSwitchLinks[sectionIndex];   
   }
   function taskPanePreviousSectionSwitch(event, sectionIndex)
   {
      showDebugMsgs("section Switch to", sectionIndex);
      window.location =  g_viewModeSectionSwitchLinks[sectionIndex];   
   }
    /*]]>*/ </script>
    
<%
    }  else {  // NOT view mode
%>         
    <script type="text/javascript"> /*<![CDATA[*/
   function taskPaneSectionSwitch(event, selector) {
       if (selector.options[selector.selectedIndex].value == "-999")
       {
          // Have to reset the selected option in dropdown to the current section
          // because the user can cancel from the new section dialog
          // resulting in the dropdown selection being out-of-sync with the current section.
          var index = '<%=currentSectionIndex%>';
          selector.selectedIndex = index;
          rsSubmit('/sendEditorState.do', 'WrsEdit.newSection()');
       }
       else
       {
          rsSubmit('/sendEditorState.do', 'WrsEdit.changeSection',  selector.options[selector.selectedIndex].value);
       }   
   }    
   function taskPaneNextSectionSwitch(event, sectionIndex) {
       rsSubmit('/sendEditorState.do',  'WrsEdit.changeSection',  sectionIndex);
   } 
   function taskPanePreviousSectionSwitch(event, sectionIndex) {
       rsSubmit('/sendEditorState.do',  'WrsEdit.changeSection',  sectionIndex);
   }
    /*]]>*/ </script>
<%
    }   
 } catch (Exception ex) {
    PageErrorProcessor.setJspError(ex, pageContext, out);
} // END: DEBUG %>